import { animate, state, style, transition, trigger } from '@angular/animations';
import { ResourceLoader } from '@angular/compiler';
import { Component, OnInit } from '@angular/core';
import * as Parse from "parse";
@Component({
  selector: 'app-job-recommend',
  templateUrl: './job-recommend.page.html',
  styleUrls: ['./job-recommend.page.scss'],
  animations: [
    trigger('moveAnimation', [
      state('move', style({
        transform: 'translate({{x}}, {{y}})'
      }), { params: { x: '0', y: '0' } }),
      transition('* => move', animate('2s ease-out'))
    ])
  ]
})
export class JobRecommendPage implements OnInit {
  testresult:any
  result:string | undefined
  suitablejobs:any
  balls = [
    { text:'',color: 'red', x: 50, y: 50, vx: 2, vy: 1 },
    { text:'',color: 'blue', x: 100, y: 100, vx: -1, vy: 2 },
    { text:'',color: 'green', x: 150, y: 150, vx: 1, vy: -2 }
  ];
  maxX = window.innerWidth-100;
  maxY = window.innerHeight-300;

  constructor() {
  }
  saveTextToLocalStorage(text: string) {
    localStorage.setItem('clickedText', text);
  }
  moveBalls() {
    this.balls.forEach(ball => {
      ball.x += ball.vx;
      ball.y += ball.vy;

      if (ball.x <= 0 || ball.x >= this.maxX) {
        ball.vx = -ball.vx;
      }

      if (ball.y <= 0 || ball.y >= this.maxY) {
        ball.vy = -ball.vy;
      }
    });
  }
  ngOnInit() {
    setInterval(() => {
      this.maxX = window.innerWidth-100;
      this.maxY = window.innerHeight-320;
      this.moveBalls();
    }, 10);
    let user = Parse.User.current();
    if(user?.id){
      var testresult=user.get("mbti")
    }
    this.testresult=testresult
    let BoleMbti = Parse.Object.extend("BoleMbti");
    const query = new Parse.Query(BoleMbti);
    query.equalTo("result", testresult);
    query.first().then((result) => {
      if (result) {
          this.result=result.get("result")
          const suitableJobs = result.get("suitableJobs");
          this.suitablejobs=suitableJobs
          console.log(suitableJobs[0])
          for(var i=0;i<3;i++){
            this.balls[i].text=suitableJobs[i]
          }
      } else {
          console.log("未找到符合条件的数据");
      }
  }).catch((error) => {
      console.error("查询数据时出错：", error);
  });
  }

}
